using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

using Telerik.Web.UI;

using BE;
using BL;
using Utilitaria;


public partial class InstUpd_SubDiarios : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["Usuario"] == null)
        {
            ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CloseAndRebind();", true);
        }
        this.txtNomenclatura.Focus();
        if (!IsPostBack)
        {
            llenaCombo();
            if (ViewState["SubDiarioID"] != null) { BuscaRegistro(); } else { this.ddlEstado2.SelectedValue = Utilitaria.Cls_Enums.EstadoModulos.Activo; }
        }

        //ddlTipoFormatoGGPP.Filter = (RadComboBoxFilter)Convert.ToInt32(2);
    }


    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);

        if (Request.QueryString["SubDiarioID"] == null)
        {
            this.btnGuardar.Text = "  Crear  "; 
        }
        else
        {
            this.btnGuardar.Text = "Actualizar";
            ViewState["SubDiarioID"] = Request.QueryString["SubDiarioID"].ToString().Trim();
        }
    }

    private void llenaCombo()
    {
        this.ddlEstado2.Items.Insert(0, new RadComboBoxItem("Activo"));
        this.ddlEstado2.Items[0].Value = Utilitaria.Cls_Enums.EstadoModulos.Activo;

        this.ddlEstado2.Items.Insert(1, new RadComboBoxItem("Inactivo"));
        this.ddlEstado2.Items[1].Value = Utilitaria.Cls_Enums.EstadoModulos.Inactivo;
    }

    private void BuscaRegistro()
    {

        BESubDiarios objet_SubDiarios = new BESubDiarios();
        BLSubDiarios objlg_SubDiarios = new BLSubDiarios();
        List<BESubDiarios> Datos;

        Datos = objlg_SubDiarios.fnSelSubDiariosDin("SubDiarioID=" + Convert.ToString(ViewState["SubDiarioID"]), "");

        ViewState["SubDiarioID"] = Datos[0].SubDiarioID;

        // Inicio Variables auditoras ///
        ViewState["CodigoSubDiario"] = Datos[0].CodigoSubDiario;
        ViewState["NombreSubDiario"] = Datos[0].NombreSubDiario;
        ViewState["Estado"] = Datos[0].Estado;
        ViewState["Orden"] = Datos[0].Orden;
        ///////FIN//////////

        this.txtNomenclatura.Text = Convert.ToString(ViewState["CodigoSubDiario"]);
        this.txtNombre.Text = Convert.ToString(ViewState["NombreSubDiario"]);
        this.ddlEstado2.SelectedValue = Convert.ToString(ViewState["Estado"]);
        this.txtOrden.Text = Convert.ToString(ViewState["Orden"]);
        objet_SubDiarios = null;
        objlg_SubDiarios = null;
        Datos = null;

    }


    private void limpiarCampos()
    {
        ViewState["SubDiarioID"] = "";
        this.txtNombre.Text = String.Empty;
        this.txtNomenclatura.Text = String.Empty;
        this.ddlEstado2.SelectedValue = Utilitaria.Cls_Enums.EstadoModulos.Todos;

    }


    protected void btnGuardar_Click(object sender, EventArgs e)
    {

        BESubDiarios objet_SubDiarios = new BESubDiarios();
        BLSubDiarios objlg_SubDiarios = new BLSubDiarios();

        String strSubDiarioID = Convert.ToString(ViewState["SubDiarioID"]);
        String strRegistro;
        String strActualiza;
       
        ViewState["New_CodigoSubDiario"] = this.txtNomenclatura.Text;
        ViewState["New_NombreSubDiario"] = this.txtNombre.Text;
        ViewState["New_Estado"] = Convert.ToByte(this.ddlEstado2.SelectedValue);
        if (this.txtOrden.Text == "") { this.txtOrden.Text = "0"; } 
        ViewState["New_Orden"] = this.txtOrden.Text;

        objet_SubDiarios.SubDiarioID = strSubDiarioID;
        objet_SubDiarios.CodigoSubDiario = Convert.ToString(ViewState["New_CodigoSubDiario"]).Trim();
        objet_SubDiarios.NombreSubDiario = Convert.ToString(ViewState["New_NombreSubDiario"]).Trim();
        objet_SubDiarios.Estado = Convert.ToByte(ViewState["New_Estado"]);
        objet_SubDiarios.EstablecimientoID = Convert.ToInt32(Session["EmpresaID"]);
        objet_SubDiarios.Orden = Convert.ToString(ViewState["New_Orden"]);

        strRegistro = "<<Creo SubDiarios>>" +
                      "\n<CodigoSubDiario>=" + ViewState["New_CodigoSubDiario"] +
                      "\n<NombreSubDiario>=" + ViewState["New_NombreSubDiario"] +
                      "\n<Estado>=" + ViewState["New_Estado"] +
                      "\n<EstablecimientoID>=" + Session["EmpresaID"]+
                      "\n<OrdenSubdiario>="+ ViewState["New_Orden"];

        //Ingresa
        objet_SubDiarios.BEAuditores.UsuarioID = Convert.ToInt32(Session["UsuarioID"]);
        objet_SubDiarios.BEAuditores.Movimiento = strRegistro;
        objet_SubDiarios.BEAuditores.UsuarioIdAutorizado = 0;
        objet_SubDiarios.BEAuditores.IPEquipo = Cls_Enums.f_DatosPC.IPPC;
        objet_SubDiarios.BEAuditores.UsuarioActualEquipo = Cls_Enums.f_DatosPC.UsuarioPC;
        objet_SubDiarios.BEAuditores.NombreEquipo = Cls_Enums.f_DatosPC.NombrePC;
        objet_SubDiarios.BEAuditores.TablaMovimientoID = Cls_Enums.TablaMovimientos.SubDiarios;

        if (strSubDiarioID != String.Empty)
        {
            //Update
            strRegistro = "<<Actualiza SubDiarios>>" +
                          "\n<CodigoSubDiario>=" + ViewState["CodigoSubDiario"] +
                          "\n<NombreSubDiario>=" + ViewState["NombreSubDiario"] +
                          "\n<Estado>=" + ViewState["Estado"]+
                          "\n<EstablecimientoID>=" + Session["EmpresaID"]+
                          "\n<OrdenSubdiario>=" + ViewState["Orden"];

            strActualiza = "<<Actualiza SubDiarios>>" +
                           "\n<CodigoSubDiario>=" + ViewState["New_CodigoSubDiario"] +
                           "\n<NombreSubDiario>=" + ViewState["New_NombreSubDiario"] +
                           "\n<Estado>=" + ViewState["New_Estado"]+
                           "\n<EstablecimientoID>=" + Session["EmpresaID"]+
                           "\n<OrdenSubdiario>=" + ViewState["New_Orden"]; ;

            objet_SubDiarios.BEAuditores.Movimiento = strRegistro;
            objet_SubDiarios.BEAuditores.MovimientoUltimo = strActualiza;
            ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CloseAndRebind();", true);
        }
        else
        {
            ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CloseAndRebind('navigateToInserted');", true);
        }
        
        try
        {
            int registro= objlg_SubDiarios.fnInsUpdSubDiarios(objet_SubDiarios);
            if (registro > 0) { showMessage("Los Datos que ingreso ya esta registrado"); return; };
        }
        catch (Exception ex)
        {
            showMessage(ex.Message.ToString());
        }


        objet_SubDiarios = null;
        objlg_SubDiarios = null;
        this.limpiarCampos();
    }
    protected void btnVolver_Click(object sender, EventArgs e)
    {
        ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CancelEdit();", true);
        this.limpiarCampos();
    }
    protected void showMessage(string strMessage)
    {
        ScriptManager.RegisterStartupScript(this, this.GetType(), "myscript", "alert('" + strMessage + "');", true);

    }

}
